/*
 * Copyright 2013 serso aka se.solovyev
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Contact details
 *
 * Email: se.solovyev@gmail.com
 * Site:  http://se.solovyev.org/java/jcl
 */

package org.solovyev.common.listeners;

import javax.annotation.Nonnull;
import java.util.EventListener;

/**
 * User: serso
 * Date: 2/1/13
 * Time: 9:19 PM
 */
public interface JEventListener<E extends JEvent> extends EventListener {

	/**
	 * @return type of supported event
	 */
	@Nonnull
	Class<E> getEventType();

	/**
	 * Method which is called after {@link JEventListeners#fireEvent(E)} of the container is called
	 *
	 * @param event event to be processed by current listener
	 */
	void onEvent(@Nonnull E event);
}
